﻿using System;
using SQLitePCL;
using Microsoft.Data.Sqlite;

namespace LiteSync_Console
{
    class Program
    {
        static void Main(string[] args)
        {
            //Console.WriteLine("Starting...");

            // load the LiteSync native library
            SQLitePCL.raw.SetProvider(new SQLite3Provider_LiteSync());
            SQLitePCL.raw.FreezeProvider(true);
            Console.WriteLine($"native library: {SQLitePCL.raw.GetNativeLibraryName()}");

            // open the database
            var uri = "file:test.db?node=primary&bind=tcp://0.0.0.0:1122";
            var db = new SqliteConnection("Data Source=" + uri);
            Console.WriteLine($"System SQLite version: {db.ServerVersion}");
            db.Open();

            // check if the db is ready
            while (true)
            {
                SqliteCommand cmd = db.CreateCommand();
                cmd.CommandText = "pragma sync_status";
                string status = (string)cmd.ExecuteScalar();
                if (status == null)
                {
                    Console.WriteLine("the loaded library does not contain LiteSync");
                    return;
                }
                if (status.Contains("\"db_is_ready\": true")) break;
                System.Threading.Thread.Sleep(250);
            }

            // now we can use the database
            Console.WriteLine("done.");
        }
    }
}
